<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful';
import { FooterEditLinkMixin, LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { assemblePageContent } from '~/services/jobs/jobs.service';

import SolutionsHero from '~/components/solutions/hero.vue';
import { BySolutionValueProp as Benefits } from '~/components/solutions/by-solution/index.vue';
import BadgeCard from '~/components/jobs/badge-card.vue';
import { BySolutionValueProp } from '~/components/solutions/by-solution/index.vue';
import {
  CopyAbout,
  CopyMission,
  CopyNumbers,
} from '~/components/company/index.vue';
import { NextStepAlt } from '~/components/common/index.vue';
import CardBlock from '~/components/jobs/card-block.vue';
export default Vue.extend({
  name: 'Jobs',
  components: {
    Benefits,
    BySolutionValueProp,
    SolutionsHero,
    NextStepAlt,
    CopyAbout,
    CopyMission,
    CopyNumbers,
    CardBlock,
    BadgeCard,
  },
  nuxtI18n: false,
  mixins: [LivePreviewMixin, FooterEditLinkMixin],
  async asyncData() {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '1kYJ8ZDxSbt6qPgKPrS17E',
        include: 10,
      });
      const spaceId = items[0].sys.space.sys.id;
      const entryId = items[0].sys.id;

      const pageContent = assemblePageContent(items);

      return { items, pageContent, spaceId, entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).pageContent.metadata,
      this.$route.path,
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.pageContent = assemblePageContent(updatedData)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div class="jobs">
    <component
      :is="component.name"
      v-for="component in pageContent.components"
      :key="component.name"
      :data="component.data"
    />
    <NextStepAlt />
  </div>
</template>

<style lang="scss" scoped>
.jobs {
  overflow-x: hidden;
}
</style>
